Index: code/trunk/src/orxonox/core/DebugLevel.cc
===================================================================
--- code/trunk/src/orxonox/core/DebugLevel.cc	(revision 790)
+++ code/trunk/src/orxonox/core/DebugLevel.cc	(revision 790)
@@ -0,0 +1,106 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/*!
+    @file DebugLevel.cc
+    @brief Implementation of the DebugLevel class.
+*/
+
+#include "DebugLevel.h"
+
+namespace orxonox
+{
+    /**
+        @brief Constructor: Registers the object and sets the debug level.
+        @param A reference to a global variable, used to avoid an infinite recursion in getSoftDebugLevel()
+    */
+    DebugLevel::DebugLevel(bool& bReturnSoftDebugLevel)
+    {
+        RegisterRootObject(DebugLevel);
+        this->setConfigValues();
+        bReturnSoftDebugLevel = true;
+    }
+
+    /**
+        @brief Function to collect the SetConfigValue-macro calls.
+    */
+    void DebugLevel::setConfigValues()
+    {
+        SetConfigValue(softDebugLevelConsole_, 3).description("The maximal level of debug output shown in the console");
+        SetConfigValue(softDebugLevelLogfile_, 3).description("The maximal level of debug output shown in the logfile");
+        SetConfigValue(softDebugLevelShell_, 1).description("The maximal level of debug output shown in the ingame shell");
+
+        // softDebugLevel_ is the maximum of the 3 variables
+        this->softDebugLevel_ = this->softDebugLevelConsole_;
+        if (this->softDebugLevelLogfile_ > this->softDebugLevel_)
+            this->softDebugLevel_ = this->softDebugLevelLogfile_;
+        if (this->softDebugLevelShell_ > this->softDebugLevel_)
+            this->softDebugLevel_ = this->softDebugLevelShell_;
+    }
+
+    /**
+        @brief Static function that holds the singleton.
+    */
+    int DebugLevel::getSoftDebugLevel(OutputHandler::OutputDevice device)
+    {
+        static bool bCreatingSoftDebugLevelObject = true;   // Static variable - used to enhance the performance
+        static bool bReturnSoftDebugLevel = false;          // Static variable - used to avoid an infinite recursion
+        static DebugLevel* theOnlyDebugLevelObject = 0;     // Static variable - will contain a pointer to the only instance of the DebugLevel class
+
+        // If bReturnSoftDebugLevel is true, the instance of DebugLevel was created (it's set to true at the end of the constructor, call by reference)
+        if (bReturnSoftDebugLevel)
+        {
+            if (device == OutputHandler::LD_All)
+                return theOnlyDebugLevelObject->softDebugLevel_;
+            else if (device == OutputHandler::LD_Console)
+                return theOnlyDebugLevelObject->softDebugLevelConsole_;
+            else if (device == OutputHandler::LD_Logfile)
+                return theOnlyDebugLevelObject->softDebugLevelLogfile_;
+            else if (device == OutputHandler::LD_Shell)
+                return theOnlyDebugLevelObject->softDebugLevelShell_;
+        }
+
+        // If bCreatingSoftDebugLevelObject is true, we're just about to create an instance of the DebugLevel class
+        if (bCreatingSoftDebugLevelObject)
+        {
+            bCreatingSoftDebugLevelObject = false;
+            theOnlyDebugLevelObject = new DebugLevel(bReturnSoftDebugLevel);
+            return getSoftDebugLevel(device);
+        }
+
+        // Return a constant value while we're creating the object
+        return 4;
+    }
+}
+
+/**
+    @returns the soft debug level, stored in the only existing instance of the DebugLevel class, configured in the config-file.
+*/
+int getSoftDebugLevel()
+{
+    return orxonox::DebugLevel::getSoftDebugLevel();
+}
Index: code/trunk/src/orxonox/core/DebugLevel.h
===================================================================
--- code/trunk/src/orxonox/core/DebugLevel.h	(revision 790)
+++ code/trunk/src/orxonox/core/DebugLevel.h	(revision 790)
@@ -0,0 +1,71 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/*!
+    @file DebugLevel.h
+    @brief Definition of the DebugLevel class.
+
+    The DebugLevel class is a singleton, only used to configure the amount of debug
+    output (see Debug.h) into the console and the logfile (see OutputHandler.h).
+*/
+
+#ifndef _DebugLevel_H__
+#define _DebugLevel_H__
+
+#include "CorePrereqs.h"
+
+#include "OrxonoxClass.h"
+#include "OutputHandler.h"
+#include "CoreIncludes.h"
+
+namespace orxonox
+{
+    //! The DebugLevel class is a singleton, only used to configure the amount of debug output.
+    class _CoreExport DebugLevel : public OrxonoxClass
+    {
+        template <class T>
+        friend class ClassIdentifier; // forward declaration because of the private destructor
+
+        public:
+            static int getSoftDebugLevel(OutputHandler::OutputDevice device = OutputHandler::LD_All);
+            void setConfigValues();
+
+        private:
+            explicit DebugLevel(bool& bReturnSoftDebugLevel);
+            DebugLevel(const DebugLevel& dl) {} // don't copy
+            virtual ~DebugLevel() {}            // don't delete
+
+            int softDebugLevel_;                            //!< The debug level
+            int softDebugLevelConsole_;                     //!< The debug level for the console
+            int softDebugLevelLogfile_;                     //!< The debug level for the logfile
+            int softDebugLevelShell_;                       //!< The debug level for the ingame shell
+            ConfigValueContainer* softDebugLevelContainer_; //!< The config value container for the debug level
+    };
+    ExportAbstractClass(DebugLevel, Core);
+}
+
+#endif /* _DebugLevel_H__ */
Index: code/trunk/src/orxonox/core/Error.cc
===================================================================
--- code/trunk/src/orxonox/core/Error.cc	(revision 790)
+++ code/trunk/src/orxonox/core/Error.cc	(revision 790)
@@ -0,0 +1,63 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Nicolas Perrenoud
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "Debug.h"
+#include "Error.h"
+
+namespace orxonox
+{
+	Error::Error()
+	{
+		Error(0,"");
+	}
+
+	Error::Error(std::string errorMsg, int errorCode)
+	{
+		Error(errorCode, errorMsg);
+	}
+
+	Error::Error(int errorCode, std::string errorMsg)
+	{
+		COUT(1) << "############################ "<< std::endl
+							<< "#         Error "<<errorCode<< "          #"<< std::endl
+							<< "############################ "<< std::endl
+							<< "An error occured in Orxonox: "<< std::endl;
+
+		if (errorMsg=="")
+		{
+			switch (errorCode)
+			{
+				case 1:
+					errorMsg = "Some error!";
+					break;
+				default:
+					errorMsg = "Unknown error!";
+			}
+		}
+		COUT(1) << errorMsg << std::endl<< std::endl;
+	}
+}
Index: code/trunk/src/orxonox/core/Error.h
===================================================================
--- code/trunk/src/orxonox/core/Error.h	(revision 790)
+++ code/trunk/src/orxonox/core/Error.h	(revision 790)
@@ -0,0 +1,48 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Nicolas Perrenoud
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _Error_H__
+#define _Error_H__
+
+#include <string>
+
+#include "CorePrereqs.h"
+
+namespace orxonox
+{
+	class _CoreExport Error
+	{
+	public:
+		Error();
+		Error(std::string errorMsg, int errorCode = 0);
+		Error(int errorCode, std::string errorMsg = "");
+	private:
+
+	};
+}
+
+#endif /* _Error_H__ */
Index: code/trunk/src/orxonox/core/Factory.cc
===================================================================
--- code/trunk/src/orxonox/core/Factory.cc	(revision 265)
+++ code/trunk/src/orxonox/core/Factory.cc	(revision 790)
@@ -1,23 +1,109 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/*!
+    @file Factory.cc
+    @brief Implementation of the Factory class.
+*/
+
+#include "Identifier.h"
+#include "Debug.h"
+#include "BaseObject.h"
 #include "Factory.h"
-#include "Identifier.h"
 
 namespace orxonox
 {
-    Factory* Factory::pointer_s = NULL;
-
+    /**
+        @returns the Identifier with a given name.
+        @param name The name of the wanted Identifier
+    */
     Identifier* Factory::getIdentifier(const std::string& name)
     {
-        if (!pointer_s)
-            pointer_s = new Factory;
-
-        return pointer_s->identifierMap_[name];
+        return getFactoryPointer()->identifierStringMap_[name];
     }
 
+    /**
+        @returns the Identifier with a given network ID.
+        @param id The network ID of the wanted Identifier
+    */
+    Identifier* Factory::getIdentifier(const unsigned int id)
+    {
+        return getFactoryPointer()->identifierNetworkIDMap_[id];
+    }
+
+    /**
+        @brief Adds a new Identifier to both maps.
+        @param name The name of the identifier
+        @param identifier The identifier to add
+    */
     void Factory::add(const std::string& name, Identifier* identifier)
     {
-        if (!pointer_s)
-            pointer_s = new Factory;
+        getFactoryPointer()->identifierStringMap_[name] = identifier;
+        getFactoryPointer()->identifierNetworkIDMap_[identifier->getNetworkID()] = identifier;
+    }
 
-        pointer_s->identifierMap_[name] = identifier;
+    /**
+        @brief Removes the entry with the old network ID and adds a new one.
+        @param identifier The identifier to change
+        @param oldID The old networkID
+        @param newID The new networkID
+    */
+    void Factory::changeNetworkID(Identifier* identifier, const unsigned int oldID, const unsigned int newID)
+    {
+        getFactoryPointer()->identifierNetworkIDMap_.erase(oldID);
+        getFactoryPointer()->identifierNetworkIDMap_[newID] = identifier;
+    }
+
+    /**
+        @brief Creates the class-hierarchy by creating and destroying one object of each type.
+    */
+    void Factory::createClassHierarchy()
+    {
+        COUT(3) << "*** Factory -> Create class-hierarchy" << std::endl;
+        std::map<std::string, Identifier*>::iterator it;
+        it = getFactoryPointer()->identifierStringMap_.begin();
+        (*getFactoryPointer()->identifierStringMap_.begin()).second->startCreatingHierarchy();
+        for (it = getFactoryPointer()->identifierStringMap_.begin(); it != getFactoryPointer()->identifierStringMap_.end(); ++it)
+        {
+            // To create the new branch of the class-hierarchy, we create a new object and delete it afterwards.
+            BaseObject* temp = (*it).second->fabricate();
+            delete temp;
+        }
+        (*getFactoryPointer()->identifierStringMap_.begin()).second->stopCreatingHierarchy();
+        COUT(3) << "*** Factory -> Finished class-hierarchy creation" << std::endl;
+    }
+
+    /**
+        @brief Ensures the Factory gets created in the right moment.
+        @return The Factory.
+    */
+    Factory* Factory::getFactoryPointer()
+    {
+      static Factory theOneAndOnlyFactoryInstance = Factory();
+      return &theOneAndOnlyFactoryInstance;
     }
 }
Index: code/trunk/src/orxonox/core/Factory.h
===================================================================
--- code/trunk/src/orxonox/core/Factory.h	(revision 265)
+++ code/trunk/src/orxonox/core/Factory.h	(revision 790)
@@ -1,2 +1,44 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/*!
+    @file Factory.h
+    @brief Definition of the Factory and the BaseFactory class.
+
+    The Factory is a singleton, containing two maps to map either the name or the network ID
+    of a class with the corresponding Identifier.
+
+    Usage:
+    ID(classname) or ID(networkID) returns the corresponding Identifier.
+
+
+    BaseObject is the parent of ClassFactory which is defined in ClassFactory.h.
+    It can't be defined in ClassFactory.h, because of circular dependencies.
+*/
+
 #ifndef _Factory_H__
 #define _Factory_H__
@@ -5,25 +47,32 @@
 #include <string>
 
+#include "CorePrereqs.h"
+
 namespace orxonox
 {
-    class BaseObject;
-    class Identifier;
+    class BaseObject; // Forward declaration
 
     // ###############################
     // ###         Factory         ###
     // ###############################
-    class Factory
+    //! The Factory is used to map the name or the network ID of a class with its Identifier.
+    class _CoreExport Factory
     {
         public:
             static Identifier* getIdentifier(const std::string& name);
+            static Identifier* getIdentifier(const unsigned int id);
             static void add(const std::string& name, Identifier* identifier);
+            static void changeNetworkID(Identifier* identifier, const unsigned int oldID, const unsigned int newID);
+            static void createClassHierarchy();
+
+            static Factory* getFactoryPointer();    // avoid overriding order problem in the static intialisation process
 
         private:
-            Factory() {}
-            Factory(const Factory& factory) {}
-            ~Factory() {}
+            Factory() {}                            // don't create
+            Factory(const Factory& factory) {}      // don't copy
+            ~Factory() {}                           // don't delete
 
-            static Factory* pointer_s;
-            std::map<std::string, Identifier*> identifierMap_;
+            std::map<std::string, Identifier*> identifierStringMap_;            //!< The map, mapping the name with the Identifier
+            std::map<unsigned int, Identifier*> identifierNetworkIDMap_;        //!< The map, mapping the network ID with the Identifier
     };
 
@@ -31,10 +80,12 @@
     // ###       BaseFactory       ###
     // ###############################
-    class BaseFactory
+    //! Base-class of ClassFactory. Has to be defined separate because of circular dependencies.
+    class _CoreExport BaseFactory
     {
         public:
             virtual BaseObject* fabricate() = 0;
+            virtual ~BaseFactory() {};
     };
 }
 
-#endif
+#endif /* _Factory_H__ */
Index: code/trunk/src/orxonox/core/Identifier.cc
===================================================================
--- code/trunk/src/orxonox/core/Identifier.cc	(revision 265)
+++ code/trunk/src/orxonox/core/Identifier.cc	(revision 790)
@@ -1,3 +1,36 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/*!
+    @file Identifier.cc
+    @brief Implementation of the Identifier class.
+*/
+
 #include "Identifier.h"
+#include "Factory.h"
 
 namespace orxonox
@@ -6,6 +39,9 @@
     // ###       Identifier        ###
     // ###############################
-    int Identifier::hierarchyCreatingCounter_s = 0;
+    int Identifier::hierarchyCreatingCounter_s = 0; // Set the static member variable hierarchyCreatingCounter_s to zero (this static member variable is ok: it's used in main(), not before)
 
+    /**
+        @brief Constructor: No factory, no object created, new ObjectList and a unique networkID.
+    */
     Identifier::Identifier()
     {
@@ -14,18 +50,25 @@
 
         this->children_ = new IdentifierList;
+
+        // Use a static variable because the classID gets created before main() and that's why we should avoid static member variables
+        static unsigned int classIDcounter_s = 0;
+        this->classID_ = classIDcounter_s++;
     }
 
+    /**
+        @brief Destructor: Deletes the IdentifierList containing the children.
+    */
     Identifier::~Identifier()
     {
-        delete &this->name_;
-
         delete this->children_;
     }
 
+    /**
+        @brief Initializes the Identifier with an IdentifierList containing all parents of the class the Identifier belongs to.
+        @param parents The IdentifierList containing all parents
+    */
     void Identifier::initialize(const IdentifierList* parents)
     {
-#if HIERARCHY_VERBOSE
-        std::cout << "*** Initialize " << this->name_ << "-Singleton.\n";
-#endif
+        COUT(4) << "*** Initialize " << this->name_ << "-Singleton." << std::endl;
         this->bCreatedOneObject_ = true;
 
@@ -36,5 +79,5 @@
             {
                 this->parents_.add(temp1->identifier_);
-                temp1->identifier_->getChildren().add(this);
+                temp1->identifier_->getChildren().add(this); // We're a child of our parents
 
                 temp1 = temp1->next_;
@@ -43,18 +86,47 @@
     }
 
+    /**
+        @brief Creates an object of the type the Identifier belongs to.
+        @return The new object
+    */
     BaseObject* Identifier::fabricate()
     {
         if (this->factory_)
         {
-            return this->factory_->fabricate();
+            return this->factory_->fabricate(); // We have to return a BaseObject, because we don't know the exact type.
         }
         else
         {
-            std::cout << "Error: Cannot create an object of type '" << this->name_ << "'. Class is abstract.\n";
-            std::cout << "Aborting...";
+            // Abstract classes don't have a factory and therefore can't create new objects
+            COUT(1) << "Error: Cannot create an object of type '" << this->name_ << "'. Class is abstract." << std::endl;
+            COUT(1) << "Aborting..." << std::endl;
             abort();
+            return NULL;
         }
     }
 
+    /**
+        @brief Sets the network ID to a new value and changes the entry in the Factory.
+        @param id The new network ID
+    */
+    void Identifier::setNetworkID(unsigned int id)
+    {
+        Factory::changeNetworkID(this, this->classID_, id);
+        this->classID_ = id;
+    }
+
+    /**
+        @returns a reference to the Identifier map, containing all Identifiers.
+    */
+    std::map<std::string, Identifier*>& Identifier::getIdentifierMap()
+    {
+        static std::map<std::string, Identifier*> identifierMapStaticReference = std::map<std::string, Identifier*>();
+        return identifierMapStaticReference;
+    }
+
+    /**
+        @returns true, if the Identifier is at least of the given type.
+        @param identifier The identifier to compare with
+    */
     bool Identifier::isA(const Identifier* identifier) const
     {
@@ -62,4 +134,8 @@
     }
 
+    /**
+        @returns true, if the Identifier is exactly of the given type.
+        @param identifier The identifier to compare with
+    */
     bool Identifier::isDirectlyA(const Identifier* identifier) const
     {
@@ -67,4 +143,8 @@
     }
 
+    /**
+        @returns true, if the assigned identifier is a child of the given identifier.
+        @param identifier The identifier to compare with
+    */
     bool Identifier::isChildOf(const Identifier* identifier) const
     {
@@ -72,4 +152,8 @@
     }
 
+    /**
+        @returns true, if the assigned identifier is a parent of the given identifier.
+        @param identifier The identifier to compare with
+    */
     bool Identifier::isParentOf(const Identifier* identifier) const
     {
